| Home | Libraries | People | FAQ | More

#### write_at (6 of 6 overloads)

Write a certain amount of data at a specified offset before returning.

    template<
        typename SyncRandomAccessWriteDevice,
        typename Allocator,
        typename CompletionCondition>
    std::size_t write_at(
        SyncRandomAccessWriteDevice & d,
        boost::uint64_t offset,
        basic_streambuf< Allocator > & b,
        CompletionCondition completion_condition,
        boost::system::error_code & ec);

This function is used to write a certain number of bytes of data to a random access device at a specified offset. The call will block until one of the following conditions is true:

- All of the data in the supplied `basic_streambuf` has been written.
- The completion_condition function object returns 0.

This operation is implemented in terms of zero or more calls to the device's write_some_at function.

###### Parameters

d

  The device to which the data is to be written. The type must support the SyncRandomAccessWriteDevice concept.

offset

  The offset at which the data will be written.

b

  The `basic_streambuf` object from which data will be written.

completion_condition

  The function object to be called to determine whether the write operation is complete. The signature of the function object must be:

      std::size_t completion_condition(
        // Result of latest write_some_at operation.
        const boost::system::error_code& error,

        // Number of bytes transferred so far.
        std::size_t bytes_transferred
      );

  A return value of 0 indicates that the write operation is complete. A non-zero return value indicates the maximum number of bytes to be written on the next call to the device's write_some_at function.

ec

  Set to indicate what error occurred, if any.

###### Return Value

The number of bytes written. If an error occurs, returns the total number of bytes successfully transferred prior to the error.